## psst 0.1

=== Makefile ===
VERSION = 0.1
BINDIR=usr/bin
WARNFLAGS=-Wall -Wformat
CC=gcc

CFLAGS+= -D VERSION=\"$(VERSION)\"
CFLAGS+= -D_LINUX_
#CFLAGS+= -DDEBUG -g3 -ggdb -O0 -gdwarf-2
LDFLAGS+= -DPASS2
TARGET=psst

INSTALL_PROGRAM=install -m 755 -p
DEL_FILE=rm -f

INSTALL_CONFIGFILE=install -m 644 -p
CONFIG_FILE=
CONFIG_PATH=

OBJS =  parse_config.o logger.o rapl.o perf_msr.o psst.o
OBJS +=

psst: $(OBJS) Makefile psst.h
	$(CC) ${CFLAGS} $(LDFLAGS) $(OBJS) -o $(TARGET) -lpthread -lrt -lm

install:
	- mkdir -p $(INSTALL_ROOT)/$(BINDIR)
	- $(INSTALL_PROGRAM) "$(TARGET)" "$(INSTALL_ROOT)/$(BINDIR)/$(TARGET)"
	- mkdir -p $(INSTALL_ROOT)/$(CONFIG_PATH)
	- $(INSTALL_CONFIGFILE) "$(CONFIG_FILE)" "$(INSTALL_ROOT)/$(CONFIG_PATH)"

uninstall:
	$(DEL_FILE) "$(INSTALL_ROOT)/$(BINDIR)/$(TARGET)"
	$(CONFIG_FILE) "$(CONFIG_PATH)"

clean:
	find . -name "*.o" | xargs $(DEL_FILE)
	rm -f $(TARGET)

dist:
	git tag v$(VERSION)
	git archive --format=tar --prefix="$(TARGET)-$(VERSION)/" v$(VERSION) | \
	gzip > $(TARGET)-$(VERSION).tar.gz

=== debian/changelog ===
psst (0.1-7) unstable; urgency=medium

  * Add some fixes to minor issues found with static analysis
    - parse_config: fix incorrect strncpy length (off-by-one)
    - parse_config: ensure strings copied from optarg with
      strncpy are always terminated with '\0'
    - initialize last_duty_cycle to 0.0 to avoid static
      analysis warnings

 -- Colin King <colin.king@canonical.com>  Thu, 9 Aug 2018 17:11:44 +0100

psst (0.1-6) unstable; urgency=medium

  [ Noor Mubeen ]
  * Add scale factor column to output
  [ Colin King ]
  * Remove white space from debian/control
  * Use https for debian/copyright URL

 -- Colin King <colin.king@canonical.com>  Tue, 15 May 2018 10:55:23 +0100

psst (0.1-5) unstable; urgency=medium

  * Update debian/compat to 11
  * Fix global-files-wildcard-not-first-paragraph-in-dep5-copyright

 -- Colin King <colin.king@canonical.com>  Tue, 6 Mar 2018 04:17:11 +0000

psst (0.1-4) unstable; urgency=medium

  * Fix version and verbose command line options (don't need parameters)
  * Fix version option in man page and help

 -- Colin King <colin.king@canonical.com>  Fri, 15 Dec 2017 09:22:23 +0000

psst (0.1-3) unstable; urgency=medium

  * fix a bug that caused issue when cpu0 not selected

 -- Colin King <colin.king@canonical.com>  Thu, 14 Dec 2017 10:58:14 +0000

psst (0.1-2) unstable; urgency=medium

  * update Standards-Version to 4.1.2
  * Pull in some upstream fixes:
   - Add man page makefile changes
   - logger: use logical or rather than bitwise or
   - logger: ensure 'found' is initialized to zero
   - parse_config: avoid several memory leaks on allocated strings
   - cleanups to logger, parse_config, psst
   - Fix less-than-zero comparison on an unsigned integer
   - logger: check if strtok returns null string
   - logger: move pclose to ensure fp is closed for all cases
   - psst: improve precision by casting MSEC_PER_SEC to float before
     division
   - logger: close file descriptor if open succeeds, fixes resource leak
   - logger: ensure path is initialized to avoid open on garbage path
     name
   - parse_config: check for NULL return from strtok
   - parse_config: pclose fp on error exit return path
   - logger: initialize a_diff and m_diff
   - logger: initialize buf to an empty string to avoid atoi() reading
     garbage
   - parse_config: don't use popen to read a sys file and terminate buffer

 -- Colin King <colin.king@canonical.com>  Fri, 8 Dec 2017 13:16:23 +0000

psst (0.1-1) unstable; urgency=medium

  * Initial packaging of psst (Closes: #883001)

 -- Colin King <colin.king@canonical.com>  Tue, 28 Nov 2017 12:12:11 +0100

=== debian/control ===
Source: psst
Section: devel
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Uploaders: Kamal Mostafa <kamal@whence.com>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 11)
Homepage: https://01.org/power-stress-and-shaping-tool

Package: psst
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: power stress and shaping tool
 Power Stress and Shaping Tool (PSST) is a controlled power tool
 for Intel SoC components such as CPU and GPU. PSST enables very
 fine control of stress function without its own process overhead

=== debian/watch ===
version=3
https://01.org/power-stress-and-shaping-tool/downloads \
  .*/psst-v(.+)\.tar.*\.gz

## psst 1.0

=== Makefile ===
VERSION = 1.0

BINDIR = /usr/bin
MANDIR = /usr/share/man/man1
WARNFLAGS = -Wall -Wformat
CC = gcc
CFLAGS += -D VERSION=\"$(VERSION)\"
CFLAGS += -D_LINUX_ -Wall -O2
DBG_CFLAGS = -DDEBUG -g -O0
LDFLAGS += -DPASS2
TARGET = psst

INSTALL_PROGRAM = install -m 755 -p
DEL_FILE = rm -f

SRC_PATH = ./src
OBJS =  $(SRC_PATH)/parse_config.o $(SRC_PATH)/logger.o $(SRC_PATH)/rapl.o \
	$(SRC_PATH)/perf_msr.o $(SRC_PATH)/psst.o
OBJS +=

psst: $(OBJS) Makefile
	$(CC) ${CFLAGS} $(LDFLAGS) $(OBJS) -o $(TARGET) -lpthread -lrt -lm

install:
	mkdir -p $(BINDIR)
	$(INSTALL_PROGRAM) "$(TARGET)" "$(BINDIR)/$(TARGET)"
	gzip -c psst.1 > psst.1.gz
	mv -f psst.1.gz $(MANDIR)

uninstall:
	$(DEL_FILE) "$(BINDIR)/$(TARGET)"

clean:
	find . -name "*.o" | xargs $(DEL_FILE)
	rm -f $(TARGET)

dist:
	git tag v$(VERSION)
	git archive --format=tar --prefix="$(TARGET)-$(VERSION)/" v$(VERSION) | \
	gzip > $(TARGET)-$(VERSION).tar.gz

=== debian/changelog ===
psst (1.0-9) unstable; urgency=medium

  * Orphan upload
  * Update Maintainer field to Debian QA Group <packages@qa.debian.org>
    so package can be orphaned
  * Update standards-version to v4.7.2
  * Update debian copyright to 2025
  * Update homepage URL

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Sep 2025 15:01:22 +0100

psst (1.0-8) unstable; urgency=medium

  * debian/copyright: update copyright year
  * debian/rules: add missing hardening rule
  * correct date in changelog

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 12 Jan 2024 14:13:12 +0000

psst (1.0-7) unstable; urgency=medium

  * Add patch for fix:
    parse_config: limit sscanf %s size to avoid buffer overflow in buf
    https://github.com/intel/psst/pull/26

 -- Colin Ian King <colin.i.king@gmail.com>  Sun, 24 Dec 2023 11:38:14 +0000

psst (1.0-6) unstable; urgency=medium

  * Fix fails to build source after successful build (Closes: #1046635)

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 14 Aug 2023 10:10:12 +0100

psst (1.0-5) unstable; urgency=medium

  * debian/control: update standards version to 4.6.2
  * debian/watch: add watch file
  * debian/copyright: update copyright year

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 28 Jul 2023 18:14:43 +0100

psst (1.0-4) unstable; urgency=medium

  * debian/control: update Homepage to new github location
  * debian/control: update standards version to 4.6.1
  * debian/control: update Maintainer to new email address
  * debian/copyright: correct the copyright for packaging files
  * debian/watch: remove as new upstream repo is not tagged

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 14 Dec 2022 12:23:25 +0000

psst (1.0-3) unstable; urgency=medium

  * Debian/control: update compat to 13, remove compat file,
    add Rules-Requires-Root rule

 -- Colin King <colin.king@canonical.com>  Sat, 4 Jul 2020 15:54:28 +0100

psst (1.0-2) unstable; urgency=medium

  * Fix gcc-10 build failures (Closes: #957715)
   - 9099338080ba "Fix issue#17 reported with gcc-10"

 -- Colin King <colin.king@canonical.com>  Fri, 17 Apr 2020 19:24:11 +0100

psst (1.0-1) unstable; urgency=medium

  * Sync with upstream version 1.0
   - remove debian patches as these are now all integrated into
     the upstream 1.0 version

 -- Colin King <colin.king@canonical.com>  Mon, 9 Mar 2020 10:49:23 +0000

psst (0.1-11) unstable; urgency=medium

  * Add upstream fixes:
   - ae426acb1d12 "pedantic return checks to clock_gettime"
   - c36421ce5ddf "Fix gcc 9.2.1 compile warning"

 -- Colin King <colin.king@canonical.com>  Wed, 26 Feb 2020 16:16:12 +0000

psst (0.1-10) unstable; urgency=medium

  * Add upstream fixes:
   - 6b0eb907b009 "parse_config: check for null return from strchr"
   - 479714db734f "logger: only strcmp string value if it is a valid
                   string"

 -- Colin King <colin.king@canonical.com>  Thu, 2 Jan 2020 10:41:52 +0100

psst (0.1-9) unstable; urgency=medium

  * Update to compat level 12

 -- Colin King <colin.king@canonical.com>  Mon, 12 Aug 2019 19:29:12 +0100

psst (0.1-8) unstable; urgency=medium

  * Add upstream spelling mistake fix
   - 87d2119689ee ('Trival spelling mistake fix to "couldnt"')

 -- Colin King <colin.king@canonical.com>  Sun, 7 Jul 2019 17:47:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: psst
+Rules-Requires-Root: no
 Section: devel
 Priority: optional
-Maintainer: Colin King <colin.king@canonical.com>
-Uploaders: Kamal Mostafa <kamal@whence.com>
-Standards-Version: 4.1.2
-Build-Depends: debhelper (>= 11)
-Homepage: https://01.org/power-stress-and-shaping-tool
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Standards-Version: 4.7.2
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (=13)
+Homepage: https://github.com/intel/psst
 
 Package: psst
 Architecture: i386 amd64

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?V?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/intel/psst/tags \
             (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
